import { isVue3 as $, h as f, computed as C, defineComponent as H, toRef as Y, watch as Z, ref as A, onMounted as Me, nextTick as qe, onBeforeUnmount as He, Vue2 as Ge } from "vue-demi";
import { createListenerPropsForwarder as G, pick as h, withDefaultProps as J, isHandlerKey as Je, toListenerKey as Qe, isObject as Ee, useListeners as Xe, useControlledState as Ye, isString as xe, useManualEffect as Ze, normalizeListenerKeys as V, mergeProps as R, isFunction as q } from "@visoning/vue-utility";
import { FloatingCreatorProps as Se, FloatingCreator as ee } from "@visoning/vue-floating-core";
import { InteractorProps as et, createInteractorForwardContext as tt, useInteractorForwardContext as rt, Interactor as te } from "@visoning/vue-floating-interactions";
import { createInteractorForwardContext as vr, useInteractorForwardContext as Pr } from "@visoning/vue-floating-interactions";
import { offset as ot, shift as nt, flip as at, autoPlacement as st, arrow as lt } from "@floating-ui/core";
var it = Object.defineProperty, pt = Object.defineProperties, ct = Object.getOwnPropertyDescriptors, re = Object.getOwnPropertySymbols, ut = Object.prototype.hasOwnProperty, dt = Object.prototype.propertyIsEnumerable, oe = (e, t, r) => t in e ? it(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, W = (e, t) => {
  for (var r in t || (t = {}))
    ut.call(t, r) && oe(e, r, t[r]);
  if (re)
    for (var r of re(t))
      dt.call(t, r) && oe(e, r, t[r]);
  return e;
}, ft = (e, t) => pt(e, ct(t));
const De = G(Se, ["onFloatingDataUpdate"]), vt = h(Se, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate"
]), Ce = h(et, [
  "interactions",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside"
]), Fe = {
  delay: [Number, Object],
  hoverDelay: [Number, Object],
  clickDelay: [Number, Object],
  focusDelay: [Number, Object]
}, Pt = ft(W(W(W(W({}, vt), De.props), Ce), Fe), {
  open: Boolean,
  defaultOpen: Boolean,
  disabled: Boolean,
  virtualElement: Object,
  appendTo: {},
  autoUpdateOnClosed: Boolean,
  offset: [Number, Object, Function],
  shift: [Boolean, Object],
  flip: [Boolean, Object],
  autoPlacement: [Boolean, Object],
  gpuAcceleration: Boolean,
  destoryedOnClosed: Boolean,
  floatingProps: Object,
  floatingWrapper: Function,
  popupProps: Object,
  popupWrapper: Function,
  zIndex: Number,
  "onUpdate:open": Function,
  onOpen: Function,
  onClose: Function
}), _t = {
  open: void 0,
  defaultOpen: !1,
  shift: !0,
  appendTo: "body"
}, Q = J(Pt, _t);
var Ot = Object.defineProperty, mt = Object.defineProperties, gt = Object.getOwnPropertyDescriptors, z = Object.getOwnPropertySymbols, Ie = Object.prototype.hasOwnProperty, Te = Object.prototype.propertyIsEnumerable, ne = (e, t, r) => t in e ? Ot(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, k = (e, t) => {
  for (var r in t || (t = {}))
    Ie.call(t, r) && ne(e, r, t[r]);
  if (z)
    for (var r of z(t))
      Te.call(t, r) && ne(e, r, t[r]);
  return e;
}, wt = (e, t) => mt(e, gt(t)), yt = (e, t) => {
  var r = {};
  for (var a in e)
    Ie.call(e, a) && t.indexOf(a) < 0 && (r[a] = e[a]);
  if (e != null && z)
    for (var a of z(e))
      t.indexOf(a) < 0 && Te.call(e, a) && (r[a] = e[a]);
  return r;
};
function B(e, t, r) {
  if (r = Array.isArray(r) ? r : [r], $)
    return f(e, t.data, t.scopedSlots ? wt(k({}, t.scopedSlots), {
      default: (...s) => {
        var u, O;
        return r.concat((O = (u = t.scopedSlots) == null ? void 0 : u.default) == null ? void 0 : O.call(u, ...s));
      }
    }) : r);
  const a = t.data, {
    key: _,
    ref: b,
    class: j,
    style: i,
    scopedSlots: g
  } = a, p = yt(a, [
    "key",
    "ref",
    "class",
    "style",
    "scopedSlots"
  ]), w = {}, F = {}, o = {}, { propKeys: l } = t;
  for (const s in p)
    Je(s) ? w[Qe(s)] = p[s] : l != null && l.includes(s) ? o[s] = p[s] : F[s] = p[s];
  return f(e, {
    key: _,
    ref: b,
    class: j,
    style: i,
    props: o,
    attrs: F,
    on: w,
    scopedSlots: k(k({}, g), t.scopedSlots)
  }, r);
}
let Ne, Ae, Re, Ue;
try {
  const e = require("vue");
  Ne = e.Transition, Ae = e.Teleport, Re = e.vShow, Ue = e.withDirectives;
} catch {
}
function $t(e) {
  return C(() => {
    const t = [];
    return e.offset && t.push(ot(e.offset)), e.shift && t.push(nt(K(e.shift))), e.flip && t.push(at(K(e.flip))), e.autoPlacement && t.push(st(K(e.autoPlacement))), t.concat(e.middleware || []);
  });
}
function K(e, t = {}) {
  return Ee(e) ? e : t;
}
var bt = Object.defineProperty, ae = Object.getOwnPropertySymbols, ht = Object.prototype.hasOwnProperty, jt = Object.prototype.propertyIsEnumerable, se = (e, t, r) => t in e ? bt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, le = (e, t) => {
  for (var r in t || (t = {}))
    ht.call(t, r) && se(e, r, t[r]);
  if (ae)
    for (var r of ae(t))
      jt.call(t, r) && se(e, r, t[r]);
  return e;
};
function Et(e) {
  const t = C(() => {
    const r = h(e, Object.keys(Fe));
    return xt(r);
  });
  return C(() => le(le({}, h(e, ...Object.keys(Ce), "disabled")), t.value));
}
function xt(e) {
  return Object.keys(e).reduce((t, r) => {
    const a = e[r];
    return t[r] = Ee(a) ? { active: a.open, inactive: a.close } : a, t;
  }, {});
}
var St = Object.defineProperty, Dt = Object.defineProperties, Ct = Object.getOwnPropertyDescriptors, ie = Object.getOwnPropertySymbols, Ft = Object.prototype.hasOwnProperty, It = Object.prototype.propertyIsEnumerable, pe = (e, t, r) => t in e ? St(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, y = (e, t) => {
  for (var r in t || (t = {}))
    Ft.call(t, r) && pe(e, r, t[r]);
  if (ie)
    for (var r of ie(t))
      It.call(t, r) && pe(e, r, t[r]);
  return e;
}, M = (e, t) => Dt(e, Ct(t));
const ce = {
  floating: "visoning-floating",
  popup: "visoning-popup"
}, ue = H({
  name: "VisoningPopup",
  inheritAttrs: !1,
  props: Q,
  setup(e, { slots: t, attrs: r, expose: a }) {
    const _ = Xe(), [b, j] = Ye(Y(e, "open"), Y(e, "defaultOpen")), i = (n, d) => {
      j.value = n, n !== e.open && (_.emit("update:open", n, d), _.emit(n ? "open" : "close", d));
    }, g = tt(), p = rt(), w = C(() => g.interactor.value);
    Z(w, (n) => p == null ? void 0 : p.setInteractor(n));
    const F = C(() => e.virtualElement || w.value), o = A(), l = $t(e), s = A(), u = C(() => {
      const { appendTo: n } = e;
      return n === !1 ? w.value : xe(n) ? document.querySelector(n) : n;
    });
    if (!$) {
      const n = () => {
        const { value: m } = u;
        if (!m)
          return;
        const v = new Ge({
          render() {
            return s.value;
          }
        });
        return v.$mount(), m.appendChild(v.$el), () => {
          var P;
          v.$destroy(), (P = v.$el) == null || P.remove();
        };
      }, { clear: d, reset: c } = Ze(n);
      Z(u, () => c()), Me(() => void qe(c)), He(() => d());
    }
    const O = A();
    a({
      getElements: () => ({
        floating: o.value,
        reference: w.value
      }),
      updatePosition: () => {
        var n;
        return (n = O.value) == null ? void 0 : n.updatePosition();
      },
      getFloatingData: () => {
        var n;
        return (n = O.value) == null ? void 0 : n.getFloatingData();
      }
    });
    const x = ({
      x: n,
      y: d,
      strategy: c,
      middlewareData: m
    }) => {
      const v = e.gpuAcceleration ? {
        top: 0,
        left: 0,
        transform: `translate3d(${n}px, ${d}px, 0px)`
      } : {
        top: `${d}px`,
        left: `${n}px`
      }, P = M(y({}, v), {
        position: c,
        zIndex: e.zIndex
      });
      return m.hide && !m.hide.referenceHidden && (P.visibility = "hidden"), P;
    }, I = (n, d) => {
      let c = B("div", {
        data: R(e.floatingProps, {
          ref: o,
          class: ce.floating,
          style: x(n)
        })
      }, [d]);
      if (e.floatingWrapper && (c = e.floatingWrapper(c)), $)
        return f(Ae, {
          to: u.value
        }, {
          default: () => [c]
        });
      s.value = c;
    }, U = (n) => {
      var d;
      const { value: c } = b, { destoryedOnClosed: m } = e;
      if (!c && m)
        return;
      const { popupProps: v, popupWrapper: P } = e, S = B("div", {
        data: R(v, {
          class: ce.popup
        })
      }, (d = t.default) == null ? void 0 : d.call(t, n));
      if ($)
        Ue(S, [[Re, c, "show"]]);
      else {
        const L = {
          name: "show",
          value: c
        };
        (S.data.directives || (S.data.directives = [])).push(L);
      }
      return P ? P(S) : S;
    }, ke = Et(e), Ke = (n) => {
      var d;
      const { value: c } = o, m = M(y({}, ke.value), {
        active: b.value,
        targets: c && [c]
      }), v = {
        "onUpdate:active": i
      }, P = (d = t.reference) == null ? void 0 : d.call(t);
      return $ ? f(te, y(y(y({}, r), m), v), [P, n]) : f(te, {
        attrs: r,
        props: m,
        on: V(v)
      }, P);
    };
    return () => {
      const n = e.disabled || !b.value && !e.autoUpdateOnClosed, d = {
        ref: O
      }, c = {
        reference: F.value,
        floating: o.value,
        disabled: n,
        placement: e.placement,
        strategy: e.strategy,
        autoUpdate: e.autoUpdate,
        middleware: l.value
      }, m = De.forwards(), v = {
        default: (P) => {
          const S = U(P), L = I(P, S);
          return Ke(L);
        }
      };
      return $ ? f(ee, y(y(y({}, c), m), d), v) : f(ee, M(y({}, d), {
        props: c,
        on: V(m),
        scopedSlots: v
      }));
    };
  }
});
var Tt = Object.defineProperty, Nt = Object.defineProperties, At = Object.getOwnPropertyDescriptors, de = Object.getOwnPropertySymbols, Rt = Object.prototype.hasOwnProperty, Ut = Object.prototype.propertyIsEnumerable, fe = (e, t, r) => t in e ? Tt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, ve = (e, t) => {
  for (var r in t || (t = {}))
    Rt.call(t, r) && fe(e, r, t[r]);
  if (de)
    for (var r of de(t))
      Ut.call(t, r) && fe(e, r, t[r]);
  return e;
}, Wt = (e, t) => Nt(e, At(t));
const We = G(Q, ["onFloatingDataUpdate", "onUpdate:open", "onOpen", "onClose"]), Ve = h(Q, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "interactions",
  "delay",
  "hoverDelay",
  "clickDelay",
  "focusDelay",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "floatingProps",
  "floatingWrapper",
  "zIndex"
]), Vt = Wt(ve(ve({}, Ve), We.props), {
  title: [String, Function],
  content: [String, Function],
  theme: String,
  size: String,
  transitionProps: [String, Object],
  showArrow: Boolean,
  arrow: Function,
  arrowProps: Object,
  popoverProps: Object,
  contentProps: Object,
  popoverWrapper: Function
}), ze = "visoning-popover", zt = {
  theme: "line",
  size: "meduim",
  transitionProps: ze,
  showArrow: !0
}, X = J(Vt, zt);
var Bt = Object.defineProperty, Lt = Object.defineProperties, kt = Object.getOwnPropertyDescriptors, Pe = Object.getOwnPropertySymbols, Kt = Object.prototype.hasOwnProperty, Mt = Object.prototype.propertyIsEnumerable, _e = (e, t, r) => t in e ? Bt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, D = (e, t) => {
  for (var r in t || (t = {}))
    Kt.call(t, r) && _e(e, r, t[r]);
  if (Pe)
    for (var r of Pe(t))
      Mt.call(t, r) && _e(e, r, t[r]);
  return e;
}, Oe = (e, t) => Lt(e, kt(t));
const T = {
  popover: "visoning-popover",
  content: "visoning-popover-content",
  title: "visoning-popover-title",
  arrow: "visoning-popover-arrow",
  dark: "theme-dark"
}, me = H({
  name: "VisoningPopover",
  inheritAttrs: !1,
  props: X,
  setup(e, { attrs: t, expose: r, slots: a }) {
    const _ = A(), b = ({
      placement: o,
      middlewareData: l
    }) => {
      var s, u, O, E;
      const x = (u = (s = l.arrow) == null ? void 0 : s.y) != null ? u : 0, I = (E = (O = l.arrow) == null ? void 0 : O.x) != null ? E : 0, U = {
        "--vp-arrow-top": `${x}px`,
        "--vp-arrow-left": `${I}px`
      };
      return o.includes("top") || o.includes("bottom") ? U.left = `${I}px` : U.top = `${x}px`, U;
    }, j = (o) => {
      const l = e.arrow || a.arrow;
      return l ? l(o) : f("div", {
        ref: _,
        class: T.arrow,
        style: b(o)
      });
    }, i = C(() => {
      const o = e.middleware || [];
      return e.showArrow && _.value && o.push(lt({
        element: _.value
      })), o;
    }), g = (o) => {
      const { transitionProps: l } = e;
      if (l) {
        const s = xe(l) ? { name: l } : D({
          name: ze
        }, l);
        if ($) {
          const u = o;
          o = f(Ne, s, {
            default: () => u
          });
        } else
          o = f("transition", {
            props: s
          }, [o]);
      }
      return e.popoverWrapper ? e.popoverWrapper(o) : o;
    }, p = A();
    r({
      updatePosition: () => {
        var o;
        return (o = p.value) == null ? void 0 : o.updatePosition();
      },
      getFloatingData: () => {
        var o;
        return (o = p.value) == null ? void 0 : o.getFloatingData();
      },
      getElements: () => {
        var o;
        return ((o = p.value) == null ? void 0 : o.getElements()) || {};
      }
    });
    const F = (o) => {
      var l, s, u;
      const O = (l = e.title) != null ? l : a.title, E = (u = (s = e.content) != null ? s : a.content) != null ? u : a.default, x = q(O) ? O() : O, I = q(E) ? E() : E;
      return B("div", {
        data: R(e.popoverProps, {
          class: [
            T.popover,
            `size-${e.size}`,
            e.theme === "dark" && T.dark
          ],
          "data-placement": o.placement
        })
      }, [
        B("div", {
          data: R(e.contentProps, {
            class: T.content
          })
        }, [
          x && f("div", {
            class: T.title
          }, [x]),
          I
        ]),
        e.showArrow && j(o)
      ]);
    };
    return () => {
      const o = {
        ref: p
      }, l = Oe(D({}, h(e, Object.keys(Ve))), {
        middleware: i.value,
        popupWrapper: g,
        popupProps: R(e.popoverProps, {
          class: T.popover
        })
      }), s = We.forwards(), u = {
        reference: a.reference,
        default: F
      };
      return $ ? f(ue, D(D(D(D({}, t), l), s), o), u) : f(ue, Oe(D({}, o), {
        props: l,
        on: V(s),
        attrs: t,
        scopedSlots: u
      }));
    };
  }
});
var qt = Object.defineProperty, Ht = Object.defineProperties, Gt = Object.getOwnPropertyDescriptors, ge = Object.getOwnPropertySymbols, Jt = Object.prototype.hasOwnProperty, Qt = Object.prototype.propertyIsEnumerable, we = (e, t, r) => t in e ? qt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, ye = (e, t) => {
  for (var r in t || (t = {}))
    Jt.call(t, r) && we(e, r, t[r]);
  if (ge)
    for (var r of ge(t))
      Qt.call(t, r) && we(e, r, t[r]);
  return e;
}, Xt = (e, t) => Ht(e, Gt(t));
const Be = G(X, ["onFloatingDataUpdate", "onUpdate:open", "onOpen", "onClose"]), Le = h(X, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "interactions",
  "delay",
  "hoverDelay",
  "clickDelay",
  "focusDelay",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "floatingProps",
  "floatingWrapper",
  "zIndex",
  "content",
  "theme",
  "size",
  "transitionProps",
  "showArrow",
  "arrow",
  "arrowProps",
  "contentProps"
]), Yt = Xt(ye(ye({}, Le), Be.props), {
  textAlign: String,
  tooltipProps: Object,
  tooltipWrapper: Function
}), Zt = {
  interactions: "hover",
  theme: "drak",
  textAlign: "start",
  allowPointerEnterTarget: !1
}, er = J(Yt, Zt);
var tr = Object.defineProperty, rr = Object.defineProperties, or = Object.getOwnPropertyDescriptors, $e = Object.getOwnPropertySymbols, nr = Object.prototype.hasOwnProperty, ar = Object.prototype.propertyIsEnumerable, be = (e, t, r) => t in e ? tr(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, N = (e, t) => {
  for (var r in t || (t = {}))
    nr.call(t, r) && be(e, r, t[r]);
  if ($e)
    for (var r of $e(t))
      ar.call(t, r) && be(e, r, t[r]);
  return e;
}, he = (e, t) => rr(e, or(t));
const je = {
  tooltip: "visoning-tooltip",
  content: "visoning-tooltip-content"
}, ur = H({
  name: "Tooltip",
  inheritAttrs: !1,
  props: er,
  setup(e, { attrs: t, slots: r, expose: a }) {
    const _ = A();
    a({
      updatePosition: () => {
        var i;
        return (i = _.value) == null ? void 0 : i.updatePosition();
      },
      getFloatingData: () => {
        var i;
        return (i = _.value) == null ? void 0 : i.getFloatingData();
      },
      getElements: () => {
        var i;
        return ((i = _.value) == null ? void 0 : i.getElements()) || {};
      }
    });
    const j = () => {
      var i, g;
      const p = (g = (i = e.content) != null ? i : r.content) != null ? g : r.default;
      return f("div", {
        style: {
          textAlign: e.textAlign
        }
      }, [
        f("span", {
          class: je.content
        }, [q(p) ? p() : p])
      ]);
    };
    return () => {
      const i = {
        ref: _
      }, g = he(N({}, h(e, Object.keys(Le))), {
        popoverProps: R(e.tooltipProps, {
          class: je.tooltip
        }),
        popoverWrapper: e.tooltipWrapper
      }), p = Be.forwards(), w = {
        reference: r.reference,
        arrow: r.arrow,
        content: j
      };
      return $ ? f(me, N(N(N(N({}, t), g), p), i), w) : f(me, he(N({}, i), {
        props: g,
        on: V(p),
        attrs: t,
        scopedSlots: w
      }));
    };
  }
});
export {
  me as Popover,
  T as PopoverClassNames,
  zt as PopoverDefaultProps,
  X as PopoverProps,
  Vt as PopoverPropsType,
  ze as PopoverTransitionName,
  ue as Popup,
  _t as PopupDefaultProps,
  Q as PopupProps,
  Pt as PopupPropsType,
  ur as Tooltip,
  je as TooltipClassNames,
  Zt as TooltipDefaultProps,
  er as TooltipProps,
  Yt as TooltipPropsType,
  vr as createInteractorForwardContext,
  Pr as useInteractorForwardContext
};
